# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class ModifyChartsetEvent(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, chart_name=None, custom_charts=None, operation=None):
        """
        ModifyChartsetEvent - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'chart_name': 'str',
            'custom_charts': 'int',
            'operation': 'str'
        }

        self.attribute_map = {
            'chart_name': 'chartName',
            'custom_charts': 'customCharts',
            'operation': 'operation'
        }

        self._chart_name = chart_name
        self._custom_charts = custom_charts
        self._operation = operation

    @property
    def chart_name(self):
        """
        Gets the chart_name of this ModifyChartsetEvent.


        :return: The chart_name of this ModifyChartsetEvent.
        :rtype: str
        """
        return self._chart_name

    @chart_name.setter
    def chart_name(self, chart_name):
        """
        Sets the chart_name of this ModifyChartsetEvent.


        :param chart_name: The chart_name of this ModifyChartsetEvent.
        :type: str
        """
        
        self._chart_name = chart_name

    @property
    def custom_charts(self):
        """
        Gets the custom_charts of this ModifyChartsetEvent.


        :return: The custom_charts of this ModifyChartsetEvent.
        :rtype: int
        """
        return self._custom_charts

    @custom_charts.setter
    def custom_charts(self, custom_charts):
        """
        Sets the custom_charts of this ModifyChartsetEvent.


        :param custom_charts: The custom_charts of this ModifyChartsetEvent.
        :type: int
        """
        
        self._custom_charts = custom_charts

    @property
    def operation(self):
        """
        Gets the operation of this ModifyChartsetEvent.


        :return: The operation of this ModifyChartsetEvent.
        :rtype: str
        """
        return self._operation

    @operation.setter
    def operation(self, operation):
        """
        Sets the operation of this ModifyChartsetEvent.


        :param operation: The operation of this ModifyChartsetEvent.
        :type: str
        """
        
        self._operation = operation

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other




