# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class Billing(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, projects=None, seats=None, summary=None):
        """
        Billing - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'projects': 'list[ProjectBilling]',
            'seats': 'SeatsBilling',
            'summary': 'BillingSummary'
        }

        self.attribute_map = {
            'projects': 'projects',
            'seats': 'seats',
            'summary': 'summary'
        }

        self._projects = projects
        self._seats = seats
        self._summary = summary

    @property
    def projects(self):
        """
        Gets the projects of this Billing.


        :return: The projects of this Billing.
        :rtype: list[ProjectBilling]
        """
        return self._projects

    @projects.setter
    def projects(self, projects):
        """
        Sets the projects of this Billing.


        :param projects: The projects of this Billing.
        :type: list[ProjectBilling]
        """
        
        self._projects = projects

    @property
    def seats(self):
        """
        Gets the seats of this Billing.


        :return: The seats of this Billing.
        :rtype: SeatsBilling
        """
        return self._seats

    @seats.setter
    def seats(self, seats):
        """
        Sets the seats of this Billing.


        :param seats: The seats of this Billing.
        :type: SeatsBilling
        """
        
        self._seats = seats

    @property
    def summary(self):
        """
        Gets the summary of this Billing.


        :return: The summary of this Billing.
        :rtype: BillingSummary
        """
        return self._summary

    @summary.setter
    def summary(self, summary):
        """
        Sets the summary of this Billing.


        :param summary: The summary of this Billing.
        :type: BillingSummary
        """
        
        self._summary = summary

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other




