# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class DateTimeFilter(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, value_filter=None, interval_filter=None, duration_filter=None):
        """
        DateTimeFilter - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'value_filter': 'DateTimeValueFilter',
            'interval_filter': 'DateTimeIntervalFilter',
            'duration_filter': 'DateTimeDurationFilter'
        }

        self.attribute_map = {
            'value_filter': 'valueFilter',
            'interval_filter': 'intervalFilter',
            'duration_filter': 'durationFilter'
        }

        self._value_filter = value_filter
        self._interval_filter = interval_filter
        self._duration_filter = duration_filter

    @property
    def value_filter(self):
        """
        Gets the value_filter of this DateTimeFilter.


        :return: The value_filter of this DateTimeFilter.
        :rtype: DateTimeValueFilter
        """
        return self._value_filter

    @value_filter.setter
    def value_filter(self, value_filter):
        """
        Sets the value_filter of this DateTimeFilter.


        :param value_filter: The value_filter of this DateTimeFilter.
        :type: DateTimeValueFilter
        """
        
        self._value_filter = value_filter

    @property
    def interval_filter(self):
        """
        Gets the interval_filter of this DateTimeFilter.


        :return: The interval_filter of this DateTimeFilter.
        :rtype: DateTimeIntervalFilter
        """
        return self._interval_filter

    @interval_filter.setter
    def interval_filter(self, interval_filter):
        """
        Sets the interval_filter of this DateTimeFilter.


        :param interval_filter: The interval_filter of this DateTimeFilter.
        :type: DateTimeIntervalFilter
        """
        
        self._interval_filter = interval_filter

    @property
    def duration_filter(self):
        """
        Gets the duration_filter of this DateTimeFilter.


        :return: The duration_filter of this DateTimeFilter.
        :rtype: DateTimeDurationFilter
        """
        return self._duration_filter

    @duration_filter.setter
    def duration_filter(self, duration_filter):
        """
        Sets the duration_filter of this DateTimeFilter.


        :param duration_filter: The duration_filter of this DateTimeFilter.
        :type: DateTimeDurationFilter
        """
        
        self._duration_filter = duration_filter

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other




