# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class EntitiesPath(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, organization=None, project=None, group=None, experiment=None):
        """
        EntitiesPath - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'organization': 'OrganizationWithRole',
            'project': 'ProjectWithRole',
            'group': 'Group',
            'experiment': 'Experiment'
        }

        self.attribute_map = {
            'organization': 'organization',
            'project': 'project',
            'group': 'group',
            'experiment': 'experiment'
        }

        self._organization = organization
        self._project = project
        self._group = group
        self._experiment = experiment

    @property
    def organization(self):
        """
        Gets the organization of this EntitiesPath.


        :return: The organization of this EntitiesPath.
        :rtype: OrganizationWithRole
        """
        return self._organization

    @organization.setter
    def organization(self, organization):
        """
        Sets the organization of this EntitiesPath.


        :param organization: The organization of this EntitiesPath.
        :type: OrganizationWithRole
        """
        
        self._organization = organization

    @property
    def project(self):
        """
        Gets the project of this EntitiesPath.


        :return: The project of this EntitiesPath.
        :rtype: ProjectWithRole
        """
        return self._project

    @project.setter
    def project(self, project):
        """
        Sets the project of this EntitiesPath.


        :param project: The project of this EntitiesPath.
        :type: ProjectWithRole
        """
        
        self._project = project

    @property
    def group(self):
        """
        Gets the group of this EntitiesPath.


        :return: The group of this EntitiesPath.
        :rtype: Group
        """
        return self._group

    @group.setter
    def group(self, group):
        """
        Sets the group of this EntitiesPath.


        :param group: The group of this EntitiesPath.
        :type: Group
        """
        
        self._group = group

    @property
    def experiment(self):
        """
        Gets the experiment of this EntitiesPath.


        :return: The experiment of this EntitiesPath.
        :rtype: Experiment
        """
        return self._experiment

    @experiment.setter
    def experiment(self, experiment):
        """
        Sets the experiment of this EntitiesPath.


        :param experiment: The experiment of this EntitiesPath.
        :type: Experiment
        """
        
        self._experiment = experiment

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other




