# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class ExperimentTemplateParams(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, hostname=None, remote_params=None, entrypoint=None, properties=None, config_path=None, exec_args_template=None, parameters=None, enqueue_command=None):
        """
        ExperimentTemplateParams - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'hostname': 'str',
            'remote_params': 'QueuedRemoteExperimentParams',
            'entrypoint': 'str',
            'properties': 'list[KeyValueProperty]',
            'config_path': 'str',
            'exec_args_template': 'str',
            'parameters': 'list[Parameter]',
            'enqueue_command': 'str'
        }

        self.attribute_map = {
            'hostname': 'hostname',
            'remote_params': 'remoteParams',
            'entrypoint': 'entrypoint',
            'properties': 'properties',
            'config_path': 'configPath',
            'exec_args_template': 'execArgsTemplate',
            'parameters': 'parameters',
            'enqueue_command': 'enqueueCommand'
        }

        self._hostname = hostname
        self._remote_params = remote_params
        self._entrypoint = entrypoint
        self._properties = properties
        self._config_path = config_path
        self._exec_args_template = exec_args_template
        self._parameters = parameters
        self._enqueue_command = enqueue_command

    @property
    def hostname(self):
        """
        Gets the hostname of this ExperimentTemplateParams.


        :return: The hostname of this ExperimentTemplateParams.
        :rtype: str
        """
        return self._hostname

    @hostname.setter
    def hostname(self, hostname):
        """
        Sets the hostname of this ExperimentTemplateParams.


        :param hostname: The hostname of this ExperimentTemplateParams.
        :type: str
        """
        
        self._hostname = hostname

    @property
    def remote_params(self):
        """
        Gets the remote_params of this ExperimentTemplateParams.


        :return: The remote_params of this ExperimentTemplateParams.
        :rtype: QueuedRemoteExperimentParams
        """
        return self._remote_params

    @remote_params.setter
    def remote_params(self, remote_params):
        """
        Sets the remote_params of this ExperimentTemplateParams.


        :param remote_params: The remote_params of this ExperimentTemplateParams.
        :type: QueuedRemoteExperimentParams
        """
        
        self._remote_params = remote_params

    @property
    def entrypoint(self):
        """
        Gets the entrypoint of this ExperimentTemplateParams.


        :return: The entrypoint of this ExperimentTemplateParams.
        :rtype: str
        """
        return self._entrypoint

    @entrypoint.setter
    def entrypoint(self, entrypoint):
        """
        Sets the entrypoint of this ExperimentTemplateParams.


        :param entrypoint: The entrypoint of this ExperimentTemplateParams.
        :type: str
        """
        
        self._entrypoint = entrypoint

    @property
    def properties(self):
        """
        Gets the properties of this ExperimentTemplateParams.


        :return: The properties of this ExperimentTemplateParams.
        :rtype: list[KeyValueProperty]
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """
        Sets the properties of this ExperimentTemplateParams.


        :param properties: The properties of this ExperimentTemplateParams.
        :type: list[KeyValueProperty]
        """
        
        self._properties = properties

    @property
    def config_path(self):
        """
        Gets the config_path of this ExperimentTemplateParams.


        :return: The config_path of this ExperimentTemplateParams.
        :rtype: str
        """
        return self._config_path

    @config_path.setter
    def config_path(self, config_path):
        """
        Sets the config_path of this ExperimentTemplateParams.


        :param config_path: The config_path of this ExperimentTemplateParams.
        :type: str
        """
        
        self._config_path = config_path

    @property
    def exec_args_template(self):
        """
        Gets the exec_args_template of this ExperimentTemplateParams.


        :return: The exec_args_template of this ExperimentTemplateParams.
        :rtype: str
        """
        return self._exec_args_template

    @exec_args_template.setter
    def exec_args_template(self, exec_args_template):
        """
        Sets the exec_args_template of this ExperimentTemplateParams.


        :param exec_args_template: The exec_args_template of this ExperimentTemplateParams.
        :type: str
        """
        
        self._exec_args_template = exec_args_template

    @property
    def parameters(self):
        """
        Gets the parameters of this ExperimentTemplateParams.


        :return: The parameters of this ExperimentTemplateParams.
        :rtype: list[Parameter]
        """
        return self._parameters

    @parameters.setter
    def parameters(self, parameters):
        """
        Sets the parameters of this ExperimentTemplateParams.


        :param parameters: The parameters of this ExperimentTemplateParams.
        :type: list[Parameter]
        """
        
        self._parameters = parameters

    @property
    def enqueue_command(self):
        """
        Gets the enqueue_command of this ExperimentTemplateParams.


        :return: The enqueue_command of this ExperimentTemplateParams.
        :rtype: str
        """
        return self._enqueue_command

    @enqueue_command.setter
    def enqueue_command(self, enqueue_command):
        """
        Sets the enqueue_command of this ExperimentTemplateParams.


        :param enqueue_command: The enqueue_command of this ExperimentTemplateParams.
        :type: str
        """
        
        self._enqueue_command = enqueue_command

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other




