# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class LeaderboardColumn(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, id=None, pinned=None, width=None, column_type=None):
        """
        LeaderboardColumn - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'pinned': 'bool',
            'width': 'int',
            'column_type': 'ColumnTypeEnum'
        }

        self.attribute_map = {
            'id': 'id',
            'pinned': 'pinned',
            'width': 'width',
            'column_type': 'columnType'
        }

        self._id = id
        self._pinned = pinned
        self._width = width
        self._column_type = column_type

    @property
    def id(self):
        """
        Gets the id of this LeaderboardColumn.


        :return: The id of this LeaderboardColumn.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this LeaderboardColumn.


        :param id: The id of this LeaderboardColumn.
        :type: str
        """
        
        self._id = id

    @property
    def pinned(self):
        """
        Gets the pinned of this LeaderboardColumn.


        :return: The pinned of this LeaderboardColumn.
        :rtype: bool
        """
        return self._pinned

    @pinned.setter
    def pinned(self, pinned):
        """
        Sets the pinned of this LeaderboardColumn.


        :param pinned: The pinned of this LeaderboardColumn.
        :type: bool
        """
        
        self._pinned = pinned

    @property
    def width(self):
        """
        Gets the width of this LeaderboardColumn.


        :return: The width of this LeaderboardColumn.
        :rtype: int
        """
        return self._width

    @width.setter
    def width(self, width):
        """
        Sets the width of this LeaderboardColumn.


        :param width: The width of this LeaderboardColumn.
        :type: int
        """
        
        self._width = width

    @property
    def column_type(self):
        """
        Gets the column_type of this LeaderboardColumn.


        :return: The column_type of this LeaderboardColumn.
        :rtype: ColumnTypeEnum
        """
        return self._column_type

    @column_type.setter
    def column_type(self, column_type):
        """
        Sets the column_type of this LeaderboardColumn.


        :param column_type: The column_type of this LeaderboardColumn.
        :type: ColumnTypeEnum
        """
        
        self._column_type = column_type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other




