# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class LimitedChannelValues(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, channel_id=None, values=None, total_item_count=None):
        """
        LimitedChannelValues - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'channel_id': 'str',
            'values': 'list[Point]',
            'total_item_count': 'int'
        }

        self.attribute_map = {
            'channel_id': 'channelId',
            'values': 'values',
            'total_item_count': 'totalItemCount'
        }

        self._channel_id = channel_id
        self._values = values
        self._total_item_count = total_item_count

    @property
    def channel_id(self):
        """
        Gets the channel_id of this LimitedChannelValues.


        :return: The channel_id of this LimitedChannelValues.
        :rtype: str
        """
        return self._channel_id

    @channel_id.setter
    def channel_id(self, channel_id):
        """
        Sets the channel_id of this LimitedChannelValues.


        :param channel_id: The channel_id of this LimitedChannelValues.
        :type: str
        """
        
        self._channel_id = channel_id

    @property
    def values(self):
        """
        Gets the values of this LimitedChannelValues.


        :return: The values of this LimitedChannelValues.
        :rtype: list[Point]
        """
        return self._values

    @values.setter
    def values(self, values):
        """
        Sets the values of this LimitedChannelValues.


        :param values: The values of this LimitedChannelValues.
        :type: list[Point]
        """
        
        self._values = values

    @property
    def total_item_count(self):
        """
        Gets the total_item_count of this LimitedChannelValues.


        :return: The total_item_count of this LimitedChannelValues.
        :rtype: int
        """
        return self._total_item_count

    @total_item_count.setter
    def total_item_count(self, total_item_count):
        """
        Sets the total_item_count of this LimitedChannelValues.


        :param total_item_count: The total_item_count of this LimitedChannelValues.
        :type: int
        """
        
        self._total_item_count = total_item_count

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other




