# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class NamedFilterParams(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, organization_name=None, project_name=None, name=None, filters=None):
        """
        NamedFilterParams - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'organization_name': 'str',
            'project_name': 'str',
            'name': 'str',
            'filters': 'FilteringConditions'
        }

        self.attribute_map = {
            'organization_name': 'organizationName',
            'project_name': 'projectName',
            'name': 'name',
            'filters': 'filters'
        }

        self._organization_name = organization_name
        self._project_name = project_name
        self._name = name
        self._filters = filters

    @property
    def organization_name(self):
        """
        Gets the organization_name of this NamedFilterParams.


        :return: The organization_name of this NamedFilterParams.
        :rtype: str
        """
        return self._organization_name

    @organization_name.setter
    def organization_name(self, organization_name):
        """
        Sets the organization_name of this NamedFilterParams.


        :param organization_name: The organization_name of this NamedFilterParams.
        :type: str
        """
        
        self._organization_name = organization_name

    @property
    def project_name(self):
        """
        Gets the project_name of this NamedFilterParams.


        :return: The project_name of this NamedFilterParams.
        :rtype: str
        """
        return self._project_name

    @project_name.setter
    def project_name(self, project_name):
        """
        Sets the project_name of this NamedFilterParams.


        :param project_name: The project_name of this NamedFilterParams.
        :type: str
        """
        
        self._project_name = project_name

    @property
    def name(self):
        """
        Gets the name of this NamedFilterParams.


        :return: The name of this NamedFilterParams.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this NamedFilterParams.


        :param name: The name of this NamedFilterParams.
        :type: str
        """
        
        self._name = name

    @property
    def filters(self):
        """
        Gets the filters of this NamedFilterParams.


        :return: The filters of this NamedFilterParams.
        :rtype: FilteringConditions
        """
        return self._filters

    @filters.setter
    def filters(self, filters):
        """
        Sets the filters of this NamedFilterParams.


        :param filters: The filters of this NamedFilterParams.
        :type: FilteringConditions
        """
        
        self._filters = filters

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other




