# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class OrganizationMember(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, registered_member_info=None, role=None, invitation_info=None):
        """
        OrganizationMember - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'registered_member_info': 'RegisteredMemberInfo',
            'role': 'OrganizationRole',
            'invitation_info': 'InvitationInfo'
        }

        self.attribute_map = {
            'registered_member_info': 'registeredMemberInfo',
            'role': 'role',
            'invitation_info': 'invitationInfo'
        }

        self._registered_member_info = registered_member_info
        self._role = role
        self._invitation_info = invitation_info

    @property
    def registered_member_info(self):
        """
        Gets the registered_member_info of this OrganizationMember.


        :return: The registered_member_info of this OrganizationMember.
        :rtype: RegisteredMemberInfo
        """
        return self._registered_member_info

    @registered_member_info.setter
    def registered_member_info(self, registered_member_info):
        """
        Sets the registered_member_info of this OrganizationMember.


        :param registered_member_info: The registered_member_info of this OrganizationMember.
        :type: RegisteredMemberInfo
        """
        
        self._registered_member_info = registered_member_info

    @property
    def role(self):
        """
        Gets the role of this OrganizationMember.


        :return: The role of this OrganizationMember.
        :rtype: OrganizationRole
        """
        return self._role

    @role.setter
    def role(self, role):
        """
        Sets the role of this OrganizationMember.


        :param role: The role of this OrganizationMember.
        :type: OrganizationRole
        """
        
        self._role = role

    @property
    def invitation_info(self):
        """
        Gets the invitation_info of this OrganizationMember.


        :return: The invitation_info of this OrganizationMember.
        :rtype: InvitationInfo
        """
        return self._invitation_info

    @invitation_info.setter
    def invitation_info(self, invitation_info):
        """
        Sets the invitation_info of this OrganizationMember.


        :param invitation_info: The invitation_info of this OrganizationMember.
        :type: InvitationInfo
        """
        
        self._invitation_info = invitation_info

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other




