# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class ProjectSize(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, storage_size=None, channels_size=None, total_size=None):
        """
        ProjectSize - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'storage_size': 'int',
            'channels_size': 'int',
            'total_size': 'int'
        }

        self.attribute_map = {
            'storage_size': 'storageSize',
            'channels_size': 'channelsSize',
            'total_size': 'totalSize'
        }

        self._storage_size = storage_size
        self._channels_size = channels_size
        self._total_size = total_size

    @property
    def storage_size(self):
        """
        Gets the storage_size of this ProjectSize.


        :return: The storage_size of this ProjectSize.
        :rtype: int
        """
        return self._storage_size

    @storage_size.setter
    def storage_size(self, storage_size):
        """
        Sets the storage_size of this ProjectSize.


        :param storage_size: The storage_size of this ProjectSize.
        :type: int
        """
        
        self._storage_size = storage_size

    @property
    def channels_size(self):
        """
        Gets the channels_size of this ProjectSize.


        :return: The channels_size of this ProjectSize.
        :rtype: int
        """
        return self._channels_size

    @channels_size.setter
    def channels_size(self, channels_size):
        """
        Sets the channels_size of this ProjectSize.


        :param channels_size: The channels_size of this ProjectSize.
        :type: int
        """
        
        self._channels_size = channels_size

    @property
    def total_size(self):
        """
        Gets the total_size of this ProjectSize.


        :return: The total_size of this ProjectSize.
        :rtype: int
        """
        return self._total_size

    @total_size.setter
    def total_size(self, total_size):
        """
        Sets the total_size of this ProjectSize.


        :param total_size: The total_size of this ProjectSize.
        :type: int
        """
        
        self._total_size = total_size

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other




